#include "ctoolbar.h"
#include "ceventredirector.h"

//-----------------------------------------------------------------------------
// Event table

BEGIN_EVENT_TABLE(cToolbar, wxToolBar)
END_EVENT_TABLE()

//-----------------------------------------------------------------------------

cToolbar::cToolbar(wxWindow* parent, long style)
: wxToolBar(parent, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxTB_HORIZONTAL | wxNO_BORDER | style)
{
  m_Tooltips = false;
  m_ShouldBeHidden = false;

  RedirectEvents(this, NULL, true, false); // redirect scrollwheel events to the window at the pointer
}

//-----------------------------------------------------------------------------

cToolbar::~cToolbar()
{
}

//-----------------------------------------------------------------------------
// Enable/disable tooltips

void cToolbar::EnableToolTips(bool flag)
{
  if (m_Tooltips == flag) return; // no change

  m_Tooltips = flag;
  TranslateTexts();
  Refresh();
}
